//********************************************************
// Class PrintContent
// Print  a Content
//
// use jQuery
//********************************************************

var PrintContent = Class.create( {

    // Public functions ********************************************************

    initialize: function()
    {
        this.divWrapper = $( '<div id="printWrapper"></div>' );
        this.divButtons = $( '<div id="printButtons"></div>' );
        this.divContent = $( '<div id="printContent"></div>' );

//        this.print_frame = $( '<iframe id="print-modal-content" scrolling="no" border="0" frameborder="0" name="print-frame" />' );
        this.content = $( document.createElement( "div" ) );
        this.content.append( $( "#leftTop" ).clone() );
        this.divContent.append( this.content );
    },

    displayPrintPreview: function()
    {
        this.divWrapper.hide();
        this.divWrapper.append( this.divButtons );
        this.divWrapper.append( this.divContent );
//        this.divWrapper.append( this.print_frame );
        $( 'body' ).append( this.divWrapper );

        // The frame lives
//        for( var i = 0; i < window.frames.length; i++ )
//        {
//            if( window.frames[i].name == "print-frame" )
//            {
//                this.print_frame_ref = window.frames[i].document;
//                break;
//            }
//        }

//        this.print_frame_ref.open();
//        this.print_frame_ref.write( '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">' +
//                '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">' +
//                '<head><title>zzzzzzzzzzz</title></head>' +
//                '<body></body>' +
//                '</html>' );
//        this.print_frame_ref.close();

//        if( !$.browser.msie && !($.browser.version < 7) )
//        {
//            $( 'head', this.print_frame_ref ).append( "headhhhhh" );
//            $( 'body', this.print_frame_ref ).append( this.content );
//        }
//        else
//        {
//            $( 'body > *:not(#printWrapper):not(script)' ).clone().each( function()
//            {
//                $( 'body', this.print_frame_ref ).append( this.outerHTML );
//            } );
//            $( 'head link[media*=print], head link[media=all]' ).each( function()
//            {
//                $( 'head', this.print_frame_ref ).append( $( this ).clone().attr( 'media', 'all' )[0].outerHTML );
//            } );
//        }

        this.loadMask();

        // Disable scrolling
//        $( 'body' ).css( {overflowY: 'hidden', height: '100%'} );
//        $( 'img', this.print_frame_ref ).load( function()
//        {
//            this.print_frame.height( $( 'body', this.print_frame.contents() )[0].scrollHeight );
//        } );

        // Position modal
        var starting_position = $( window ).height() + $( window ).scrollTop();
        var css = {
            top:         starting_position,
            height:      '100%',
            overflowY:   'auto',
            zIndex:      10000,
            display:     'block'
        }

        this.divWrapper.css( css ).animate( { top: $( window ).scrollTop()}, 400, 'linear', jQuery.proxy( function()
        {
            this.divButtons.fadeIn( 'slow' ).focus();
        }, this ) );

//        this.print_frame.height( $( 'body', this.print_frame.contents() )[0].scrollHeight );
//        this.print_frame.height( $( 'body', this.print_frame.contents() )[0].scrollHeight );
        this.createButtons();
    },

    createButtons: function()
    {
        this.oldContent = window.document.body.innerHTML;
        this.printButton = $( document.createElement( "div" ) );
        this.printButton.addClass( "print" );
        this.printButton.bind( "click", jQuery.proxy( function()
        {
//            this.mask.animate( { opacity: 1}, 400, jQuery.proxy( function()
//            {
            window.print();
//            }, this ) );

//            var thePopup = window.open( '', "Customer Listing", "menubar=0,location=0,height=700,width=700" );
//            thePopup.document.body.innerHTML = this.content;
//            this.divWrapper.clone().appendTo( thePopup.document.body );
//            thePopup.print();
//            window.open()
//            window.document.body.innerHTML = "paf";
//            document.location.href = "";
        }, this ) );
        this.divButtons.append( this.printButton );

        this.closeButton = $( document.createElement( "div" ) );
        this.closeButton.addClass( "close" );
        this.closeButton.bind( "click", jQuery.proxy( function()
        {
            this.distroyPrintPreview();
        }, this ) );
        this.divButtons.append( this.closeButton );
    },

//    printdiv: function( printpage )
//    {
//        var headstr = "<html><head><title></title></head><body>";
//        var footstr = "</body>";
//        var newstr = document.all.item( printpage ).innerHTML;
//        var newstr = "<div>qsdqmsdkqsmdkqsd</div>";
//        var oldstr = document.body.innerHTML;
//        document.body.innerHTML = headstr + newstr + footstr;
//        window.print();
//        document.body.innerHTML = oldstr;
//        return false;
//    },

    distroyPrintPreview: function()
    {
        this.divButtons.fadeOut( 100 );
        this.divWrapper.animate( { top: $( window ).scrollTop() - $( window ).height(), opacity: 1}, 400, 'linear', jQuery.proxy( function()
        {
            this.divWrapper.remove();
            $( 'body' ).css( {overflowY: 'auto', height: 'auto'} );
        }, this ) );
        this.mask.fadeOut( 'slow', jQuery.proxy( function()
        {
            this.mask.remove();
        }, this ) );

        $( document ).unbind( "keydown.printPreview.mask" );
        this.mask.unbind( "click.printPreview.mask" );
        $( window ).unbind( "resize.printPreview.mask" );
    },

    loadMask: function()
    {
        this.size = this.getMaskSize();
        this.mask = $( '<div id="divMask" />' ).appendTo( $( 'body' ) );
        this.mask.css( {
            position:           'absolute',
            top:                0,
            left:               0,
            width:              this.size[0],
            height:             this.size[1],
            display:            'none',
            opacity:            0,
            zIndex:             9999,
            backgroundColor:    '#000'
        } );

        this.mask.css( {display: 'block'} ).fadeTo( '400', 0.75 );

        $( window ).bind( "resize.printPreview.mask", jQuery.proxy( function()
        {
            this.updateMaskSize();
        }, this ) );

        this.mask.bind( "click.printPreview.mask", jQuery.proxy( function( e )
        {
            this.distroyPrintPreview();
        }, this ) );

        $( document ).bind( "keydown.printPreview.mask", jQuery.proxy( function( e )
        {
            if( e.keyCode == 27 )
            {
                this.distroyPrintPreview();
            }
        }, this ) );
    },

    getMaskSize: function()
    {
        if( $.browser.msie )
        {
            // if there are no scrollbars then use window.height
            var d = $( document ).height(), w = $( window ).height();
            return [
                window.innerWidth || // ie7+
                        document.documentElement.clientWidth || // ie6
                        document.body.clientWidth,                     // ie6 quirks mode
                d - w < 20 ? w : d
            ];
        }
        else
            return [$( document ).width(), $( document ).height()];
    },

    updateMaskSize: function()
    {
        this.size = this.getMaskSize();
        this.mask.css( {width: this.size[0], height: this.size[1]} );
    }
} );
